#!/bin/sh
#

function usage () {
    echo "Utilisation: $0 fichier taille"
    exit 1
}


# tester la validite des arguments
if [ $# -lt 3 -o ! -f "$1" ]; then usage; fi
expr "$2" : "^[0-9]\{1,\}$" > /dev/null 2>&1
[ $? -eq 0 ] && [ $2 -ge 1 ] || usage

# taille du fichier source
taille=`stat -c '%s' "$1"`
echo "Nous chiffrons $1, de taille $taille"

# eclater le fichier source 
rm -f x??
split -d -b $2 "$1" ||exit 2


# crypter parallelement
src="$1"
s=$2
shift; shift

# chargement de la liste des hotes a partir de ~/.machines
hotes=$(echo $(cat ~/.machines) | sed "s/ /:/g")
liste=""
for f in x??; do
    h=${hotes%%:*}         # tete de liste
    hotes=${hotes#*:}:$h  # faire tourner la liste pour l'iteration suivante
    ssh $h "~/bin/asep -r -s $s -i $PWD/$f -o $PWD/${f}.asep $* && rm $PWD/$f" &
    echo "Cryptage de $f -> ${f}.asep sur hote $h -> PID $! lance"
    liste="$liste $!"
done

for pid in $liste; do
    echo -n "J'attends le PID $pid..."
    wait $pid
    retcode=$?  # sauvegarde necessaire, sinon $? reflete le code de echo
    echo "recu avec le code $retcode"
    if [ $retcode -gt 0 ]; then
	echo "Stop"
	exit 1
    fi
done



