#!/bin/sh
#

function usage () {
    echo "Utilisation: $0 fichier taille clefs"
    exit 1
}


# tester la validite des arguments
if [ $# -lt 3 -o ! -f "$1" ]; then usage; fi
expr "$2" : "^[0-9]\{1,\}$" > /dev/null 2>&1
[ $? -eq 0 ] && [ $2 -ge 1 ] || usage

# taille du fichier source
taille=`stat -c '%s' "$1"`
echo "Nous chiffrons $1, de taille $taille"

# eclater le fichier source 
rm -f x??
split -d -b $2 "$1" ||exit 2


# crypter parallelement
src="$1"
s=$2
shift; shift

# chargement de la liste des hotes a partir de ~/.machines
hotes=$(echo $(cat ~/.machines) | sed "s/ /:/g")
liste=""

# version avec dd
nblocs=$((taille/s))
if [ $((taille%s)) -gt 0 ]; then
    nblocs=$((nblocs+1))
fi
i=0
while [ $i -lt $nblocs ]; do
    h=${hotes%%:*}         # tete de liste
    hotes=${hotes#*:}:$h  # faire tourner la liste pour l'iteration suivante
    nom=`printf "$PWD/x%2.2d.asep" $i`
    dd if="$src" bs=$s skip=$i count=1 | ssh $h "~/bin/asep -r -s $s -o $nom $*" &
    echo "Cryptage de $f -> ${f}.asep sur hote $h -> PID $! lance"
    liste="$liste $!"
    i=$((i+1))
done

for pid in $liste; do
    echo -n "J'attends le PID $pid..."
    wait $pid
    retcode=$?  # sauvegarde necessaire, sinon $? reflete le code de echo
    echo "recu avec le code $retcode"
    if [ $retcode -gt 0 ]; then
	echo "Stop"
	exit 1
    fi
done

cat x??.asep > ${src}.asep && rm x??.asep

